/* bonehShaw.h */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <limits.h>
#include <math.h>
#include <fcntl.h>

/* Typedef */
typedef unsigned long word;
typedef unsigned long long dword;

typedef struct codeParam {
  word n1;
  word q;
  word n2;
  word M;
  long r;    
  word t;
  double ICepsilon;
  double expr;
  int nrOfBits;

  int nrOfBlocksIC;
  int lenLastBlockIC;
  int nrOfBlocksOC;
  int lenLastBlockOC;
  int nrInBlockOC;
  int nrOfBytes;
}cParam;

/* Define constants */
#define BS_WORD 32
#define BS_DWORD 64
#define ULLONG_MAX 0xffffffffffffffffULL

/* Define macros */
#define CLE printf("Correct syntax:  progName [OPTIONS] n2" \
                   " M q r [Optional t]\n"), exit(1)
#define EOM(code)  ((code == NULL) ? printf("Error on malloc"), exit(1): NULL)
#define UOF printf("Unable to open the file %s",TXTFILE), exit(1)

/* Define config_options */
#define TXTFILE "outercode.txt"
/* Nr of collusions we want to create on the same outer code */
#define NPC 1000
/* How many proaram runs we want...(How many outer codes we want to create) */
#define NOC 1

/* Functions */
cParam getCodeParam(int argc,char *argv[]);
int chkIfDigit(char argv[]);
cParam setProp(cParam p);
void genOuterCode(cParam param);
void printNonBinaryCode(cParam param);
int trace(long **everyPos, word **pirates, cParam p, int flagP);
void getPartOfCC(dword *innerCode, word *outerCode,
	cParam p, word userNr, int OCpos);
void printBinaryCode(dword *concatCode, cParam p);
int genHybridFP(cParam p, int flagP, int flagT);
void makeHybrid(dword *hybridFP,dword **pirateCol,
		dword *feasible, cParam p, int flagP);
void findFeasible(dword *feasible, dword **pirateCol, cParam p, int flagP);
long alg1(dword *hybridFPblock, cParam p, int flagP);
void closestNDec(long **position,int *guiltyUsers,cParam p,int flagP);
word weight(dword *hybridBlock, cParam p, int s);
void getOC(int userNr, word *numbers, cParam p);
void getOCFromFile(word *code,word userNr, cParam p);
void genCollusion(word *pirates, cParam p);
double logB2(double nr);
void helpInfo(void);
void seedRNG(void);
dword getRandomDWord(void);
word getRandomWord(word q);
void init_genrand(unsigned long s);
unsigned long genrand_int32(void);
double genrand_real2(void);
