/* bsMain.c */
/*
main():
-Hentar kode variablar og sender seed data til RNG.
-Flagg blir satt etter kva brukar ynskjer. Om ein til dmes berre
ynskjer  generera ytterkoden, da blir berre 'o' gitt p kommando-
linja, og berre flagOC blir satt.
-Om flagP er satt, blir utskrift av diverse operasjonar utfrt. (Denne
utskrifts moglegheiten er i praksis berre nyttig til debugging med sm
parametere.)
-Om flagM er satt, og t er gitt, d blir genereringa av hybridFP starta.
-Om flagT er satt, og t er gitt, d blir hybridFP generert og spora,
og det blir returnert ein variabel som inneheld antallet feil oppdaga.
-Ein tidtakar er satt p heile programmet. Ein annan er satt p tida
det tek  generera ein ytterkode.
-Konstanten RUNTIMES (Gitt i bonehShaw.h) bestemmer kor mange gonger
programmet skal kyrast.

logB2():
-Funksjon som reknar ut logaritmen med base 2.
*/

#include "bonehShaw.h"

int main(int argc, char *argv[])
{
  int i,c,total,error, flagOC,flagP,flagM,flagT;
  cParam p;   /* Code parameters */
  time_t start,end, startOC, endOC;

  (void) time(&start);
  total=error=flagOC=flagP=flagM=flagT=0;

  while(--argc>0 && (*++argv)[0] == '-')
    while (c = *++argv[0])
      switch(c) {
        case 'o': /* Generate outer code */
	  flagOC=1; break;
        case 'm': /* Generate hybrid fingerprint */
	  /*flagOC=1;*/ flagM=1; break;
        case 't': /* Trace hybrid fingerprint */
	  /* flagOC=1;*/ flagM=1; flagT=1; break;
        case 'p': /* Print */
	  flagP=1; break;
        case 'h': /* Help info */
	  helpInfo(); return 0;
      }

  /* Get all code parameters. Store in struct */
  p = getCodeParam(argc, argv);

  printf("Code parameters: C1=(n1,q)=(%u,%u), C2=(n2,M)_q=(%u,%u)_%u."\
   "\n\t\t r=%d, t=%u, n=%u\n",	p.n1, p.q, p.n2, p.M, p.q, p.r,p.t,p.n1*p.n2);

  /* Set all code properties. Store in struct */
  p = setProp(p);

  seedRNG();
 
  /* Run the program a number of times... */
  for(i=0;i<NOC;i++) {
    if(flagOC==1) { /* Generate outer code */
      if(i==0) 	(void) time(&startOC);
      genOuterCode(p);
      if(i==0) (void) time(&endOC);

      if(flagP==1)  /* Print outer code */
        printNonBinaryCode(p);
    }

    if(flagM==1) { /* Generate hybrid fingerprint */
      if(p.t < p.M && p.t > 1) /* Check if t is given as argument  */
      	error = genHybridFP(p, flagP, flagT);
      else{
        printf("The number of colluding pirates(t) must be given"\
	       " as input. And t > 1\n");
        CLE;
      }
    }

    total=total+error;
  }

  if(flagT==1 && p.t>1)
    printf("Total error: %d\n", total);

  (void) time(&end);
  printf("Total running time = %d seconds\n",(int)end-(int)start);
  if(flagOC==1)
    printf("Generate OC running time = %d seconds\n",(int)endOC-(int)startOC);

  return 0;
}

/* Calculate base 2 logarithm */
/*double logB2(double nr)
{
  return log10(nr)/log10(2);
}*/
