/* oc.c */
/*
genOuterCode():
Denne funksjonen genererar og skriv ytterkoden til ei fil.
Mten den gjer dette p er  sette av minne til ein
tabell som blir nytta til  halde ytterkoden til ein brukar.
Kvar plass i tabellen rommar fleire tall. Kor mange blir avgjort
av strrelsen p q. Fyller som regel ikkje blokkene. Ofte 2 bit
overfldige i kvar blokk. Dme: Om q=20, d treng ein 5 bits for kvart tall.
32/5=6,4. Er da plass til 6 tall i kvar blokk. (2 bits som ikkje blir utnytta)
Nr alle talla for ein brukar er generert og lagra i tabellen, blir den
skrive til fil. S blir prosedyren repetert for resten av brukarane.

getOC():
Kyrer getOCFromFile(). Fr da ytterkoden til ein gitt brukar som ein tabell der
talla er lagra som mange 32 bit tall. Kvar av desse 32 bit talla inneheld
fleire tall i ytterkoden. Denne funskjonen hentar ut desse talla og
lagrar dei i ein tabell av n2 lengde. (Eit tall i ei blokk.)

getOCFromFile():
Hentar ytter koden til ein gitt brukar fr fil. Lagrar fleire
tall fr ytterkoden i samme blokka. (Som forklart over)
*/

#include "bonehShaw.h"

/* Generate and store the outer code. */
void genOuterCode(cParam p)
{
  int i,j,k, blockLen;
  FILE *fp;
  word *outerCode;

  EOM((outerCode = malloc(p.nrOfBlocksOC * sizeof(word))));
 
  if ((fp = fopen(TXTFILE, "w")) == NULL)
    UOF; /* Unable to open the file */

  blockLen = p.nrInBlockOC;
  
  for(i=0;i<p.M;i++) {  /* For all users */
    for(j=0;j<p.nrOfBlocksOC;j++) { /* For the nr of blocks we need  */
      if (j == p.nrOfBlocksOC - 1)  /* If last block */
	blockLen = p.lenLastBlockOC;

      for(k=0;k<blockLen;k++) { /* For the number of numbers in block */
	if(k==0)  /* First number in this block */
	  outerCode[j] = getRandomWord((word)p.q) << (BS_WORD-p.nrOfBits);
	else
	  outerCode[j] ^=
	    (getRandomWord((word)p.q) << (BS_WORD-((k+1)*p.nrOfBits)));
      }
    }
    blockLen = p.nrInBlockOC;
    fwrite(outerCode, p.nrOfBlocksOC, sizeof(word),fp);

    if(i==0)
      if((fp = freopen(TXTFILE,"a",fp)) == NULL)
	UOF;/* Unable to reopen the file */
  }
  printf("Outercode generated and stored\n");

  fclose(fp);
  free(outerCode);
}

/* Extract the numbers from a particular user`s outer code */
void getOC(int userNr, word *numbers, cParam p)
{
  int i,j,k,t,lenBlock;
  word mask, *outerCode;

  lenBlock = p.nrInBlockOC;
  t = 0;

  EOM((outerCode = malloc(p.nrOfBlocksOC * sizeof(word))));

  /* I will use 'mask' to mask out the current bits. First we
     set 'mask' such that we can get the first number */
  mask = ULONG_MAX << (BS_WORD-p.nrOfBits);

  getOCFromFile(outerCode, userNr, p);

  for(j=0;j<p.nrOfBlocksOC;j++) { /* For all blocks */
    if (j==p.nrOfBlocksOC-1)
      lenBlock = p.lenLastBlockOC;

    /* For all numbers in the current block */
    for(k=0;k<lenBlock;k++,t++)
      numbers[t] =(outerCode[j] &
	 (mask >>(p.nrOfBits*k))) >> (BS_WORD-(p.nrOfBits*(k+1)));
  }

  free(outerCode);
}

/* Get the outer codeword for a particular user */
void getOCFromFile(word *code, word userNr, cParam p)
{
  FILE *fp;
  fp = fopen(TXTFILE,"r");

  fseek(fp, userNr*p.nrOfBlocksOC*sizeof(word),SEEK_SET);
  fread(code, p.nrOfBlocksOC, sizeof(word),fp);

  fclose(fp);
}
